﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace XDGComboBoxField
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }
        public List<SelectableValuesViewModel> ComboList { get; set; }

        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            ComboList = new List<SelectableValuesViewModel> { 
                new SelectableValuesViewModel(EnumType.First, "Alice"),
                new SelectableValuesViewModel(EnumType.Second, "John"),
                new SelectableValuesViewModel(EnumType.Third, "William"),
                new SelectableValuesViewModel(EnumType.Fourth, "Mike"),
            };

            for (int i = 0; i < ComboList.Count(); i++)
            {
                SampleData sd = new SampleData() { Field1 = i + 1, ItemFromList = ComboList[i].Id };

                Data.Add(sd);
            }
        }


    }

    public class SampleData : ObservableModel
    {
        public int Field1 { get; set; }
        private EnumType _itemFromList;

        public EnumType ItemFromList
        {
            get { return _itemFromList; }
            set
            {
                _itemFromList = value;
                NotifyPropertyChanged();
            }
        }
    }



    public class SelectableValuesViewModel
    {
        public EnumType Id
        { get; set; }

        public string Name
        { get; set; }

        public SelectableValuesViewModel(EnumType id, string name)
        {
            this.Id = id;
            this.Name = name;
        }
    }

    public enum EnumType
    {
        First,
        Second,
        Third,
        Fourth
    }

    public class ObservableModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        public void NotifyPropertyChanged([CallerMemberName] String propertyName = "")
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
